#if   DSQUALSPEED == 1 
  #define DSQUAL  0x1F  // 0x1F  9     ~93.75 
  #define DSSPEED 6
#elif DSQUALSPEED == 2 
  #define DSQUAL  0x3F  // 0x3F 10     ~187.5
  #define DSSPEED 12
#elif DSQUALSPEED == 3 
  #define DSQUAL  0x5F  // 0x5F 11     ~375 
  #define DSSPEED 24
#elif DSQUALSPEED == 4 
  #define DSQUAL  0x7F  // 0x7F 12     ~750
  #define DSSPEED 47
#endif
#ifndef BYTE                      // 
#define BYTE unsigned char
#endif
#ifndef RBYTE					  //   
#define RBYTE register BYTE
#endif

typedef prog_uchar FBYTE;           //   FLASH 
typedef prog_char FCHAR;            //   FLASH 

#if HD4780 == 162

//-------- 
#define sch_DB4     PORTC_Bit3      //  4    
#define DDR_DB4     DDRC_Bit3       // 
#define sch_DB5     PORTC_Bit4      // 4    
#define DDR_DB5     DDRC_Bit4       // 
#define sch_DB6     PORTC_Bit5      // 4    
#define DDR_DB6     DDRC_Bit5       // 
#define sch_DB7     PORTC_Bit6      // 4    
#define DDR_DB7     DDRC_Bit6       // 
#define DDR_DATA    DDRC

//-------- 
#define sch_RS      PORTB_Bit3      // /   RS
#define DDR_RS      DDRB_Bit3       // 
#define sch_RW      PORTB_Bit4      //   / RW
#define DDR_RW      DDRB_Bit4       // 
#define sch_E       PORTB_Bit5      //     E
#define DDR_E       DDRB_Bit5       // 
#define DDR_CONTROL DDRB

#endif


struct CarbSmart{
	   unsigned int mServoMax ;     //    0-
	   unsigned int mServoCenter ;  //    1- 
	   unsigned int mServoMin ;     //    2-
	   BYTE Direction;	            //    0/1 CarbSmart
	   unsigned int Carbsmart_tempr;//   CarbSmart ( 0)
	   BYTE Carbsmart_start;        //   
}CarbSmart,* pCarbSmart;

EEMEM struct CarbSmart eCarbSmart={        // 01
									2000,  // 07B8
                                    1450,  // 05FD
									 800,  // 0618
									   0,  // 01
							  (OVERHEAT_0<<4),  // c1
							     CSSTART   // 90
									   }; 

unsigned int irq_Flag1_1, * pirq_Flag1_1; //    clock/1024/256
unsigned char TCNT2_ovf, * pTCNT2_ovf;  //  2

void Setup(void);
void init_PWM(void) ;
void ReadDSData(void);
int  main(void);